<script>
import { mapState } from 'vuex';
import { SocketState } from 'colibri-sockets';

import * as websocketsApiRoutes from '~/helpers/api-routes/websockets.js';

import AdminWebsocketCard from '~/components/admin/websocket-card.vue';

export default {
  name: `admin-websockets-dashboard`,
  components: { AdminWebsocketCard },
  data() {
    return {
      addingWebsocket: false,
      newWebsocketHost: ``,
      newWebsocketPort: ``,
    }
  },
  computed: {
    ...mapState({
      websockets: (state) => state.websockets.websockets,
      isAdmin: (state) => state.users.currentUser.roles.includes(`admin`),
    }),
    nTotalWs() {
      if (this.websockets === null) return 0;
      return this.websockets.length;
    },
    nOpenWs() {
      if (this.websockets === null) return 0;
      return this.websockets.filter((ws) => ws.state === SocketState.CONNECTED).length;
    },
  },
  methods: {
    resetNewWebsocketForm() {
      this.addingWebsocket = false;
      this.newWebsocketHost = ``;
      this.newWebsocketPort = ``;
    },
    async addWebsocket () {
      const data = { host: this.newWebsocketHost, port: this.newWebsocketPort };
      try {
        const ws = await this.$axios.$post(websocketsApiRoutes.create(), data);
        if (ws === null) {
          this.$notify({ type: `error`,
                       title: this.$t(`errors.create-websocket.title`),
                       text: this.$t(`errors.create-websocket.content.invalid-port`),
                       duration: 4000, });
        } else {
          this.$store.commit(`websockets/addWebsocket`, ws);
        }
      } catch (err) {
        this.$notify({ type: `error`,
                       title: this.$t(`errors.create-websocket.title`),
                       text: this.$t(`errors.create-websocket.content.${err.response.data.name}`),
                       duration: 4000, });
      }
      this.resetNewWebsocketForm();
    },
  },
  async mounted() {
    if (this.$store.state.websockets.websockets === null) {
      await this.$store.dispatch(`websockets/loadWebsockets`, { $axios: this.$axios });
    }
  },
}
</script>

<template>
  <cbr-dashboard
    :title="$tc(`admin.websockets.title`, 2)"
    :subtitle="nTotalWs > 0 ? `${nOpenWs} / ${nTotalWs} ${$tc(`admin.websockets.connected`, nOpenWs)}` : null"
  >
    <template v-slot:title-commands>
      <div v-if="!addingWebsocket">
        <v-btn
          v-if="isAdmin"
          fab
          x-small
          color="primary"
          :elevation="4"
          @click="addingWebsocket = true"
        >
          <v-icon>mdi-plus</v-icon>
        </v-btn>
      </div>
      <v-form v-else @submit.prevent="addWebsocket">
        <v-row align="center">
          <v-text-field
            v-model="newWebsocketHost"
            dense
            :label="$t(`admin.websockets.host`)"
            required
          />
          <v-text-field
            v-model="newWebsocketPort"
            dense
            :label="$t(`admin.websockets.port`)"
            type="number"
            class="mx-4"
            required
          />
          <v-btn icon type="submit">
            <v-icon>mdi-check</v-icon>
          </v-btn>
          <v-btn icon @click="resetNewWebsocketForm">
            <v-icon>mdi-close</v-icon>
          </v-btn>
        </v-row>
      </v-form>
    </template>
    <admin-websocket-card v-for="(websocket, idx) in websockets"
                          :key="websocket.name"
                          :websocket="websocket"
                          :idx="idx" />
  </cbr-dashboard>
</template>

<style lang="scss" scoped>
.app-admin__websockets-dashboard {
  background-color: var(--dashboard-bg);
  color: var(--dashboard-color);
  border-radius: var(--border-radius);
  padding: 1em;
}

.app-admin__websockets-dashboard__title {
  margin: 0;
}
</style>
